Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.digester
Class SetNextRule

    java.lang.Object
      org.apache.commons.digester.Rule
          org.apache.commons.digester.SetNextRule

    public class SetNextRule

extends Rule

Rule implementation that calls a method on the (top-1) (parent) object, passing the top object (child) as an argument. It is commonly used to establish parent-child relationships.

This rule now supports more flexible method matching by default. It is possible that this may break (some) code written against release 1.1.1 or earlier. See `isExactMatch()` for more details.

Note that while CallMethodRule uses commons-beanutils' data-conversion functionality (ConvertUtils class) to convert parameter values into the appropriate type for the parameter to the called method, this rule does not. Needing to use ConvertUtils functionality when building parent-child relationships is expected to be very rare; however if you do need this then instead of using this rule, create a CallMethodRule specifying targetOffset of 1 in the constructor.

Field Summary
`protected String` | `methodName` The method name to call on the parent object.
`protected String` | `paramType` The Java class name of the parameter type expected by the method.
`protected boolean` | `useExactMatch` Should we use exact matching.

Fields inherited from class org.apache.commons.digester.Rule
`digester, namespaceURI`

Constructor Summary
`SetNextRule(Digester digester, String methodName)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetNextRule(String methodName)` instead.
`SetNextRule(Digester digester, String methodName, String paramType)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetNextRule(String methodName,String paramType)` instead.
`SetNextRule(String methodName)` Construct a "set next" rule with the specified method name.
`SetNextRule(String methodName, String paramType)` Construct a "set next" rule with the specified method name.

Method Summary
`void` | `end()` Process the end of this element.
`boolean` | `isExactMatch()` Is exact matching being used.
`void` | `setExactMatch(boolean useExactMatch)` Set whether exact matching is enabled.
`String` | `toString()` Render a printable version of this Rule.

Methods inherited from class org.apache.commons.digester.Rule
`begin, begin, body, body, end, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### methodName

    protected String methodName

  The method name to call on the parent object.

### paramType

    protected String paramType

  The Java class name of the parameter type expected by the method.

### useExactMatch

    protected boolean useExactMatch

  Should we use exact matching. Default is no.

Constructor Detail

### SetNextRule

    public SetNextRule(Digester digester,
                       String methodName)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetNextRule(String methodName)` instead.

  Construct a "set next" rule with the specified method name. The method's argument type is assumed to be the class of the child object.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the parent method to call

### SetNextRule

    public SetNextRule(Digester digester,
                       String methodName,
                       String paramType)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.commons.digester.Rule)` method. Use `SetNextRule(String methodName,String paramType)` instead.

  Construct a "set next" rule with the specified method name.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the parent method to call
    `paramType` - Java class of the parent method's argument (if you wish to use a primitive type, specify the corresonding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

### SetNextRule

    public SetNextRule(String methodName)

  Construct a "set next" rule with the specified method name. The method's argument type is assumed to be the class of the child object.

  Parameters:
    `methodName` - Method name of the parent method to call

### SetNextRule

    public SetNextRule(String methodName,
                       String paramType)

  Construct a "set next" rule with the specified method name.

  Parameters:
    `methodName` - Method name of the parent method to call
    `paramType` - Java class of the parent method's argument (if you wish to use a primitive type, specify the corresonding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

Method Detail

### isExactMatch

    public boolean isExactMatch()

  Is exact matching being used.

  This rule uses `org.apache.commons.beanutils.MethodUtils` to introspect the relevent objects so that the right method can be called. Originally, `MethodUtils.invokeExactMethod` was used. This matches methods very strictly and so may not find a matching method when one exists. This is still the behaviour when exact matching is enabled.

  When exact matching is disabled, `MethodUtils.invokeMethod` is used. This method finds more methods but is less precise when there are several methods with correct signatures. So, if you want to choose an exact signature you might need to enable this property.

  The default setting is to disable exact matches.

  Returns:
    true iff exact matching is enabled
  Since:
    Digester Release 1.1.1

### setExactMatch

    public void setExactMatch(boolean useExactMatch)

  Set whether exact matching is enabled.

  See `isExactMatch()`.

  Parameters:
    `useExactMatch` - should this rule use exact method matching
  Since:
    Digester Release 1.1.1

### end

    public void end()
             throws Exception

  Process the end of this element.

  Overrides:
    `end` in class `Rule`
  Throws:
    `Exception`

### toString

    public String toString()

  Render a printable version of this Rule.

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.